(function( $ ) {
  $.ajax = function( options ) {
    var url = options.url
    ,   data = options.data
    ,   method = options.method
    ,   success = options.success
    ,   failure = options.failure
    ,   headers = options.headers || {}
    ,   authorization = options.authorization
    ,   xhr = Titanium.Network.createHTTPClient()


    if ( authorization &&
         authorization.user &&
         authorization.password ) {

      headers.Authorization = 'Basic ' +
        $.base64.encode(
          authorization.user + ':'  +
          authorization.password
        )
    }

    console.log('ajax ' + method + ' ' + url )

    xhr.onload = function() {
      if ( success && Math.floor( xhr.status / 100 ) === 2 )
        success( xhr.responseText, xhr.status, xhr )
      else if ( failure )
        failure( xhr.responseText, xhr.status, xhr )
    }

    xhr.onerror = function() {
      if ( failure ) failure( xhr.responseData, xhr.status, xhr )
    }

    xhr.open( method.toUpperCase(), url )

    _(headers).each( function ( value, key ) {
      xhr.setRequestHeader( key, value )
    })

    xhr.send( data )

    return xhr
  }

  ;'get put post'.split(' ').forEach(function( method ) {
    $[ method ] = function( url, data, success ) {
      if ( typeof data === 'function' && arguments.length === 2 ) {
        success = data, data = undefined
      }

      $.ajax({
        method: method,
        url: url,
        data: data,
        success: success
      })
    }
  })
})( tiQuery )
